//The commands are for the Partnered` Up thingies.
freeslot("S_CYAURA")

states[S_CYAURA] = {SPR_NULL, A|FF_FULLBRIGHT, 2, nil, 1, 0, S_NULL}

rawset(_G, "SNEW_Cyaura", function(player, colorr)
	local aura = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_OVERLAY)
	aura.target = player.mo
	aura.tracer = player.mo
	aura.state = S_CYAURA
	aura.skin = player.mo.skin
	aura.color = colorr
	aura.sprite = player.mo.sprite
	aura.sprite2 = player.mo.sprite2
	aura.spriteyscale = FRACUNIT + FRACUNIT/10
	aura.spritexscale = FRACUNIT + FRACUNIT/10
	aura.spriteyoffset = player.mo.spriteyoffset+(-FRACUNIT/2*5)
	aura.spritexoffset = player.mo.spritexoffset
	aura.rollangle = player.mo.rollangle
	aura.fuse = 2
	aura.colorized = true
	aura.aura = true
	AddToTable(aura,N_GlobalThinkers)
	return aura
end)

addHook("MobjThinker", function(mo) --Desparate measures...
	if mo and mo.valid
		if mo.target and mo.target.valid
		and mo.aura
			--print(leveltime..": The Bruh...")
			if mo.target.player and mo.target.player.valid
				mo.target.player.cyaura = mo
			end
			if mo.target.skin
				mo.skin = mo.target.skin
			end
			mo.sprite = mo.target.sprite
			mo.sprite2 = mo.target.sprite2
			mo.frame = mo.target.frame
			mo.blendmode = AST_ADD
		end
	end
end,MT_OVERLAY)

rawset(_G, "P_JumpTo", function(mo, fx, fy, fz, sped, addques) --A very useful command honestly.
	if mo.valid
		local flyto = P_AproxDistance(P_AproxDistance(fx - mo.x, fy - mo.y), fz - mo.z)
		if flyto < 1
			flyto = 1
		end
		local anglesucc = R_PointToAngle2(mo.x, mo.y, fx, fy)
		
		if addques
			mo.momx = $ + FixedMul(mo.scale,FixedMul(FixedDiv(fx - mo.x, flyto), sped))
			mo.momy = $ + FixedMul(mo.scale,FixedMul(FixedDiv(fy - mo.y, flyto), sped))
			mo.momz = $ + FixedMul(mo.scale,FixedMul(FixedDiv(fz - mo.z, flyto), sped)/5*3)
		else
			mo.momx = FixedMul(mo.scale,FixedMul(FixedDiv(fx - mo.x, flyto), sped))
			mo.momy = FixedMul(mo.scale,FixedMul(FixedDiv(fy - mo.y, flyto), sped))
			mo.momz = FixedMul(mo.scale,FixedMul(FixedDiv(fz - mo.z, flyto), sped)/5*3)
		end	
	end	
end) 