addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "recenttails"
		player.peelfly = $ or 0
		player.prevflyz = $ or 0
		if not CanUse(player)
		or player.powers[pw_tailsfly]
		or player.startascend
		or player.boostflying
		or (player.pflags & PF_SPINNING)
			player.peelfly = 0
			player.prevflyz = 0
			player.startthing = false
		end
		
		local function DoStartFly(player)
			if player.peelfly
				local addz = P_IsObjectOnGround(player.mo)
				local cut = (player.mo.eflags & MFE_UNDERWATER) and 2 or 1
				P_SetObjectMomZ(player.mo,(player.peelfly+abs(player.prevflyz/2))/cut,addz)
				player.mo.state = S_PLAY_FLY
				player.powers[pw_tailsfly] = (tailsflytics/4*3)+1 --You get height at start but less stamina
				
				player.pflags = $&~(PF_JUMPED|PF_NOJUMPDAMAGE|PF_SPINNING|PF_STARTDASH)
				player.pflags = $|PF_THOKKED|PF_CANCARRY
				if not (player.mo.eflags & MFE_UNDERWATER)
					if player.followmobj and player.followmobj.valid
						player.followmobj.spriteyscale = FRACUNIT/3*5
						player.followmobj.spritexscale = FRACUNIT/3
					end
					player.mo.spriteyscale = FRACUNIT/3*5
					player.mo.spritexscale = FRACUNIT/3
				end
				player.acceldash = 0
				player.stopaccel = 0
				player.doaccel = false
				P_SpawnParaloop(player.mo.x,player.mo.y,player.mo.z,player.mo.radius*3,12,MT_DUST,ANGLE_90,nil,true)
				S_StartSound(player.mo, sfx_cdfm35)
				player.startthing = false
			end
		end
		
		if player.extrabutton
		and player.cmd.buttons & player.extrabutton
			if not P_IsObjectOnGround(player.mo)
			and not (player.pflags & PF_SPINNING)
			and CanUse(player)
			and not player.powers[pw_tailsfly]
			and not player.airball
			and not player.startascend
				if player.boostflying
					player.pflags = $&~PF_THOKKED
				end
				if not (player.mo.eflags & MFE_UNDERWATER)
					if player.followmobj and player.followmobj.valid
						player.followmobj.spriteyscale = FRACUNIT/3*2
						player.followmobj.spritexscale = FRACUNIT/3*4
					end
					player.mo.spriteyscale = FRACUNIT/3*2
					player.mo.spritexscale = FRACUNIT/3*4
				end
				S_StartSound(player.mo, sfx_cdfm57)
				player.cantuseboost = 3
				player.peelfly = 0
				player.startthing = true
			end
			if player.airball
			and player.startthing
			and CanUse(player)
			and not (player.pflags & PF_SPINNING)
			and not player.powers[pw_tailsfly]
			and not player.startascend
			--and not player.boostflying
				player.cantuseboost = 3
				if player.mo.state != S_PLAY_FALL
					player.mo.state = S_PLAY_FALL
				end
				local chargecalculation = (6*(player.peelfly))/(FRACUNIT*15)
				player.peelfly = min($+FRACUNIT/4,FRACUNIT*15)
				local soundcalculation = (6*(player.peelfly))/(FRACUNIT*15)
				if not player.spectator and soundcalculation != chargecalculation
					S_StartSound(player.mo, sfx_spndsh)
				end
				player.dotailspin = true
				if P_IsObjectOnGround(player.mo)
					DoStartFly(player)
				else
					player.prevflyz = player.mo.momz
				end
			end
			player.airball = true
		else
			if player.airball
			and CanUse(player)
			and not (player.pflags & PF_SPINNING)
			and not player.powers[pw_tailsfly]
			and not player.startascend
			--and not player.boostflying
				if not (player.pflags & PF_THOKKED)
					DoStartFly(player)
				else
					player.pflags = $&~(PF_JUMPED|PF_NOJUMPDAMAGE|PF_SPINNING|PF_STARTDASH)
					player.pflags = $|PF_THOKKED
					player.acceldash = 0
					player.stopaccel = 0
					player.doaccel = false
					player.startthing = false
				end
				player.startthing = false
			end
			player.airball = false
		end
		player.noremovespin = $ or 0
		if player.noremovespin then player.noremovespin = $-1 end
		if player.dotailspin
		and (P_IsObjectOnGround(player.mo) 
			or player.powers[pw_carry] 
			or (player.mo.eflags & MFE_SPRUNG) 
			or not CanUse(player))
		and not player.noremovespin
			player.dotailspin = false
		end
	end
end)